; Applications that display data on the display screen which can print or create the PDF file
; Utvecklat av Olle Strand
; Input: String in clipboard with the following control characters (see sample documentation_testpgm)
;Free to use it.
;No warranties
;{- Enumerations / DataSections
;{ Windows
Enumeration
  #Window_0
EndEnumeration
;}
;{ Gadgets
Enumeration
  #File_RZ
  #Canvas_OUTPUT
  #Button_AVSLUTA
  #Button_PDF
  #Button_PRINT
  
EndEnumeration
;}
;{ Fonts

;}
Procedure Header()
path.s=GetCurrentDirectory()
EndProcedure

;}
Global winbredd.f,winheight.f,Pos_val$,ant_pix.f
UseJPEGImageDecoder()
DataSection
    img_0: 
    IncludeBinary "exit.jpg"
    img_1: 
    IncludeBinary "f6.jpg"
    img_2: 
    IncludeBinary "f4.jpg"
  EndDataSection
Procedure OpenWindow_Window_0()
  datornamn$ = ComputerName(); Get computorname
  
    Result = ExamineDesktops(); Width an height of display
    winbredd1 = DesktopWidth(0)
    winheight1 = DesktopHeight(0)
    
    If Pos_val$="L" ; selection landscape layout
      ant_pix.f=winheight1*0.75/210
      winheight.f =ant_pix.f*210
      winbredd.f=ant_pix.f*297
    Else              ;portrait
      ant_pix.f=winheight1*0.75/297
      winheight.f =297* ant_pix.f
      winbredd.f= ant_pix.f*210
   EndIf
  ;////Justering v innehll //////
  mitten_bredd=winbredd1/2-winbredd.f/2 ;middle of window horizontal in pixel
  mitten_height=winheight.f/2; middle vertically in pixel
  If OpenWindow(#Window_0, mitten_bredd, 5, winbredd.f*1.08, winheight.f*1.007, "PREVIEW 2.0",#PB_Window_BorderLess)
    CanvasGadget(#Canvas_OUTPUT, 3, 3, winbredd.f, winheight.f)
    Img_0 = CatchImage(#PB_Any,?img_0);Exit symbol
    ImageGadget(#Button_AVSLUTA, winbredd.f*1.012, winheight.f*0.80, 30, 30, ImageID(Img_0))
    Img_2 = CatchImage(#PB_Any,?img_2);F4 symbol
    ImageGadget(#Button_PRINT, winbredd.f*1.012, winheight.f*0.7, 30, 30, ImageID(Img_2))
     Img_1= CatchImage(#PB_Any,?img_1);F6 symbol
    ImageGadget(#Button_PDF, winbredd.f*1.012, winheight.f*0.6, 30, 30, ImageID(Img_1))
    GadgetToolTip(#Button_PDF, "Klick on symbol for PDF or press F6.")
    GadgetToolTip(#Button_PRINT, "Klick on symbol for print or press F4.")
    ; Gadget Colors
     SetWindowColor(#Window_0, $FFBF00) 
  EndIf
EndProcedure
Text$ = GetClipboardText(); data from clipboard
rad_count = CountString(Text$, Chr(13))
        Dim ut_array.s( rad_count+1)

Gosub init_out ; move to array
   
     
OpenWindow_Window_0()
visning=0; default display
Gosub subread
;{- Event loop
Repeat
  Event = WaitWindowEvent()
  Select Event
      ; ///////////////////
      Case #WM_KEYDOWN,#WM_SYSKEYDOWN
        Text$ = Str(EventwParam() - 111)
        
        Select Text$
          Case "-84"
            PostEvent(#PB_Event_Gadget, #Window_0,#Button_AVSLUTA)
            
          Case "4"
            PostEvent(#PB_Event_Gadget, #Window_0,#Button_PRINT)
           Case "6"
            PostEvent(#PB_Event_Gadget, #Window_0,#Button_PDF)
          Case "-71","-72","-73","-74"; prepared for resizing
            ;Gosub rz_win
       EndSelect
    Case #PB_Event_Gadget
      EventGadget = EventGadget()
      EventType = EventType()
      If EventGadget =  #Canvas_OUTPUT And EventType()=#PB_EventType_LeftClick
             ;Gosub utskrift
       ElseIf EventGadget = #Button_PRINT And EventType()=#PB_EventType_LeftClick
         visning=1 ; specify print to printers
         Gosub subread
       ElseIf EventGadget = #Button_PDF And EventType()=#PB_EventType_LeftClick
         visning=2 ; specify print to PDF file
         Gosub subread
       ElseIf EventGadget = #Button_AVSLUTA
        Break
      EndIf
    ; ////////////////////////
    Case #PB_Event_CloseWindow
      EventWindow = EventWindow()
      If EventWindow = #Window_0
        CloseWindow(#Window_0)
        Break
      EndIf
  EndSelect
ForEver
;
;}
End
;*************** include routine ******************************************
#PurePDF_Include=1
 XIncludeFile "PurePDF.pb"
;
;*************** end of include routine **********************************
subread:

      Select visning  ; chose output
        Case 0
            StartVectorDrawing(CanvasVectorOutput(#Canvas_OUTPUT,#PB_Unit_Millimeter)); Positioner i mm
           ; VectorFont(FontID(fnt_nbr))
            ;VectorSourceColor(RGBA(0, 0, 0, 255))
            h_mm.f=VectorOutputHeight()
           If Pos_val$="P"
             just_font.f=h_mm.f/297
           Else 
             just_font.f=h_mm.f/210
           EndIf
        Case 1
          ; Result = DefaultPrinter()
          Result = PrintRequester()
           StartPrinting("Utskrift Preview")
          StartVectorDrawing(PrinterVectorOutput(#PB_Unit_Millimeter))
     
         
       Case 2
              pdf_Init()
              Define file$=name_doc$+".pdf"
              radheigh.f=6
              pdf_Create(Pos_val$, "mm", #PDF_PAGE_FORMAT_A4)
              pdf_SetProcHeader(@Header())
              pdf_SetTopMargin(0)  
              pdf_SetLeftMargin(0)  
              pdf_SetRightMargin(0)
              pdf_AliasNbPages();
              pdf_AddPage()     ;
            
       EndSelect   
       For i=1 To  rad_count
         rad_text$=ut_array.s(i)
         kontroll$ = StringField(rad_text$,1, "/*")
         ;Debug rad_text$
          ;//////////////////////////////////////////////////////////////////////////////////////////////////  
         cmd_line$ = StringField(kontroll$,1, ",")
               Select   cmd_line$
                   Case "box"
                     cmdamd_graf$ = StringField(kontroll$, 1, ","); Catch grafic comands
                     x_graf$ = StringField(kontroll$, 2, ",")     ; x value for grafic
                     y_graf$ = StringField(kontroll$, 3, ",")     ; y value for grafic
                     w_graf$ = StringField(kontroll$, 4, ",")     ; width
                     h_graf$ = StringField(kontroll$, 5, ",")     ; hight
                     c_graf$ = StringField(kontroll$, 6, ",")     ; line colour
                     f_graf$ = StringField(kontroll$, 7, ",")     ; fill colour (F)=Fill N =no fill
                     wi_graf$ = StringField(kontroll$, 8, ",")    ; width of line in mm/10
                     Select c_graf$
                       Case "Y"
                         c_box=$FF00FF00; Vectordrawing
                          c_box_R=255; PDF drawing
                         c_box_G=255
                         c_box_B=0
                       Case "R"
                         c_box=$FF0000FF
                         c_box_R=255 ; PDF drawing
                         c_box_G=0
                         c_box_B=0
                      Case "B"
                        c_box=$FFFF0000
                        c_box_R=0; PDF drawing
                         c_box_G=0
                         c_box_B=255
                      Case "K"
                        c_box=$FF000000
                        c_box_R=0 ; PDF drawing
                         c_box_G=0
                         c_box_B=0
                     EndSelect
                  Case "img"  
                     cmdamd_graf$ = StringField(kontroll$, 1, ","); img comands
                     x_img$ = StringField(kontroll$, 2, ",")     ; x value for image
                     y_img$ = StringField(kontroll$, 3, ",")     ; y value for image
                     w_img$ = StringField(kontroll$,4, ",")     ; w value for image in mm
                     h_img$ = StringField(kontroll$, 5, ",")    ;h value for image in mm
                     f_img$ = StringField(kontroll$, 6, ",")     ;filname of image
                  Case "line"  
                     cmdamd_graf$ = StringField(kontroll$, 1, ","); line comands
                     x_line$ = StringField(kontroll$, 2, ",")     ; x value for line start
                     y_line$ = StringField(kontroll$, 3, ",")     ; y value for line start
                     xe_line$ = StringField(kontroll$, 4, ",")     ; x value for line end
                     ye_line$ = StringField(kontroll$, 5, ",")     ; y value for line end
                     c_line$ = StringField(kontroll$, 6, ",")      ; line colour
                     w_line$ = StringField(kontroll$, 7, ",")      ; line width in mm/10
                     
                     Select c_line$
                       Case "Y"
                         c_line=$FF00FF00; Vector drawing
                         c_line_R=255 ; PDF drawing
                         c_line_G=255
                         c_line_B=0
                       Case "R"
                         c_line=$FF0000FF
                         c_line_R=255
                         c_line_G=0
                         c_line_B=0
                      Case "B"
                        c_line=$FFFF0000;Vectordeawing
                        c_line_R=0; PDF drawing
                         c_line_G=0
                         c_line_B=255
                      Case "K"
                        c_line=$FF000000
                        c_line_R=0; PDF drawing
                         c_line_G=0
                         c_line_B=0
                     EndSelect
                  Case "eop"  
                    cmdamd_graf$ = StringField(kontroll$, 1, ","); eop command
                    
                  Case "txt";Text print styrtecken
                    cmdamd_graf$ = StringField(kontroll$, 1, ","); txt command
                    Font_val$ = StringField(kontroll$,2,","); select font
                        Select Font_val$
                           Case "C"
                             fo$="Courier New"
                          Case "A"
                            fo$="Arial"
                        EndSelect
                    Bold_val$ = StringField(kontroll$,3,","); Bold or Normal
                    Size_val$ = StringField(kontroll$,4,","); size of font
                    x_start$ = StringField(kontroll$,5,",")  ; startpos for x in mm
                    y_start$ = StringField(kontroll$,6,",")  ; startpos for y in mm
                    c_txt$ = StringField(kontroll$,7,",")    ; Text colour
                    Select c_txt$
                       Case "Y"
                         c_txt=$FF00FF00;Vector output
                         c_txt_R=255; PDF output
                         c_txt_G=255
                         c_txt_B=0
                       Case "R"
                         c_txt=$FF0000FF
                         c_txt_R=255
                         c_txt_G=0
                         c_txt_B=0
                      Case "B"
                        c_txt=$FFFF0000
                        c_txt_R=0
                         c_txt_G=0
                         c_txt_B=255
                      Case "K"
                        c_txt=$FF000000
                        c_txt_R=0
                         c_txt_G=0
                         c_txt_B=0
                     EndSelect
                    sz=Val(Size_val$)                       ; size of font in pixel
             EndSelect
       
        ;///////////////////////////////////////////////////////////////////////////////////////////////////      
         
              out_put$  = Mid(rad_text$,Len(kontroll$)+3); Remove first control string
      
         ;//////////////////print//////////////////
          
        Select cmdamd_graf$
            Case "box"
              Select visning
                Case 0
                     x_g.d=Val(x_graf$)*just_font.f
                     y_g.d=Val(y_graf$)*just_font.f
                     w_g.d=Val(w_graf$)*just_font.f
                     h_g.d=Val(h_graf$)*just_font.f
                    AddPathBox(x_g.d, y_g.d, w_g.d, h_g.d )
                    VectorSourceColor(c_box)
                    If f_graf$="F"
                      FillPath()
                    EndIf
                    StrokePath(0.1*Val(wi_graf$))
                Case 1
                    x_g.d=Val(x_graf$)
                    y_g.d=Val(y_graf$)
                    w_g.d=Val(w_graf$)
                     h_g.d=Val(h_graf$)
                    AddPathBox(x_g.d, y_g.d, w_g.d, h_g.d )
                    VectorSourceColor(c_box)
                    If f_graf$="F"
                      FillPath()
                    EndIf
                    StrokePath(0.1*Val(wi_graf$))
                  Case 2
                      w_gp.f=ValF(w_graf$)
                      h_gp.f=ValF(h_graf$)
                      x_gp.f=ValF(x_graf$)
                      y_gp.f=ValF(y_graf$);
                      pdf_SetLineWidth(0.1*Val(wi_graf$))
                      pdf_SetDrawColor(c_box_R,c_box_G,c_box_B)
                      If f_graf$="F"
                          pdf_SetFillColor(c_box_R,c_box_G,c_box_B)
                     EndIf
                      pdf_Rect(x_gp.f, y_gp.f, w_gp.f, h_gp.f)
                 
               EndSelect
                   cmdamd_graf$=""; clear command
            Case "img"
                   UseJPEGImageDecoder()
                  
                   bild = LoadImage(#PB_Any,  f_img$)
                   img_w = ImageWidth(bild)
                   img_h= ImageHeight(bild) 
                   Select visning
                     Case 0
                            x_i.d=Val(x_img$)*just_font.f
                            y_i.d=Val(y_img$)*just_font.f
                           w_i.d=Val(w_img$)*just_font.f*ant_pix.f
                            h_i.d=Val(h_img$)*just_font.f*ant_pix.f
                            Result = ResizeImage(bild, w_i.d , h_i.d)
                          MovePathCursor(x_i.d, y_i.d)
                          DrawVectorImage(ImageID(bild), 255) ;canvas
                      Case 1 ; printer output
                          w_i.d=Val(w_img$)
                          h_i.d=Val(h_img$)
                          x_i.d=Val(x_img$)
                          y_i.d=Val(y_img$)
                          Result = ResizeImage(bild, w_i.d , h_i.d)
                          MovePathCursor(x_i.d, y_i.d)
                          DrawVectorImage(ImageID(bild), 255,w_i.d,h_i.d); printer
                      Case 2    ;PDF output 
                           imgp_w.f=Val(w_img$)
                          imgp_h.f=Val(h_img$)
                          x_imgp.f=Val(x_img$)
                          y_imgp.f=Val(y_img$)
                          pdf_Image( f_img$,  x_imgp.f, y_imgp.f ,imgp_w.f, imgp_h.f)
                   EndSelect
                    
                   
                       cmdamd_graf$=""; clear command
                  Case "line"
                       Select visning ;line
                          Case 0 ; screen
                              x_l.d=ValF(x_line$)*just_font.f
                              y_l.d=ValF(y_line$)*just_font.f
                              xe_l.d=ValF(xe_line$)*just_font.f
                              ye_l.d=ValF(ye_line$)*just_font.f
                             MovePathCursor(x_l.d, y_l.d,#PB_Path_Default )
                             AddPathLine(xe_l.d, ye_l.d)
                             VectorSourceColor(c_line)
                              StrokePath(0.1*Val(w_line$));line thickness
                         Case 1 ;Printer
                              x_l.d=ValF(x_line$)
                              y_l.d=ValF(y_line$)
                              xe_l.d=ValF(xe_line$)
                              ye_l.d=ValF(ye_line$)
                              MovePathCursor(x_l.d, y_l.d,#PB_Path_Default )
                              AddPathLine(xe_l.d, ye_l.d)
                              VectorSourceColor(c_line)
                              StrokePath(0.1*Val(w_line$));line thickness
                         Case 2 ; PDF output
                              xp.f=ValF(x_line$)
                              yp.f=ValF(y_line$)
                              xpe.f=ValF(xe_line$)
                              ype.f=ValF(ye_line$)
                              pdf_SetLineWidth(0.1*Val(w_line$))
                              pdf_SetDrawColor(c_line_R,c_line_G,c_line_B)
                              ;Debug "Frg  "+c_line$+"  "+Str(c_line_R)+"  "+Str(c_line_G)+"  "+Str(c_line_B)
                              pdf_Line(xp.f,yp.f,xpe.f,ype.f)
                              
                      EndSelect
                    cmdamd_graf$=""; clear command
                  Case "eop" ;End of page
                    Select visning
                      Case 0; screen
                        StopVectorDrawing()
                        upsw = MessageRequester("Multiple Pages!", "Select OK if you want to see the next.", #PB_MessageRequester_YesNo)
                      If upsw = #PB_MessageRequester_Yes    ; pressed Yes button (Result = 6)StartVectorDrawing(CanvasVectorOutput(#Canvas_OUTPUT,#PB_Unit_Millimeter)); Positioner i mm
                         StartVectorDrawing(CanvasVectorOutput(#Canvas_OUTPUT,#PB_Unit_Millimeter)); Positioner i mm
                        NewPrinterPage()
                      Else
                         StartVectorDrawing(CanvasVectorOutput(#Canvas_OUTPUT,#PB_Unit_Millimeter)); Positioner i mm
                         ;NewPrinterPage()
                        Break
                      EndIf
                            AddPathBox(0,0,GadgetWidth(#Canvas_OUTPUT),GadgetHeight(#Canvas_OUTPUT)); clear canvas
                            VectorSourceColor($ffffffff)
                             FillPath()
                    Case 1 ;printer
                        NewPrinterPage()
                      Case 2 ;PDF output
                        pdf_AddPage()
                    EndSelect 
                    cmdamd_graf$=""; clear command
                Case "txt"; all text output
                      Select visning ;Text output
                        Case 0       ;Canvas output
                            If Bold_val$="B"
                              fnt_nbr=LoadFont(#PB_Any, fo$, sz* just_font.f,#PB_Font_Bold)
                           Else
                            fnt_nbr=LoadFont(#PB_Any, fo$, sz* just_font.f)
                          EndIf
                                                                           
                          x.d=Val(x_start$)*just_font.f
                          y.d=Val(y_start$)*just_font.f
                          VectorSourceColor(c_txt)
                          VectorFont(FontID(fnt_nbr))
                          MovePathCursor(x.d, y.d,#PB_Path_Default )
                          DrawVectorText(out_put$)
                        Case 1
                          If Bold_val$="B"
                              fnt_nbr=LoadFont(#PB_Any,fo$, sz,#PB_Font_Bold)
                           Else
                            fnt_nbr=LoadFont(#PB_Any, fo$, sz)
                          EndIf
                          x.d=Val(x_start$)
                          y.d=Val(y_start$)
                          VectorSourceColor(c_txt)
                          VectorFont(FontID(fnt_nbr))
                           MovePathCursor(x.d, y.d,#PB_Path_Default )
                          DrawVectorText(out_put$)
                      Case 2
                          xp.f=ValF(x_start$)
                          yp.f=ValF(y_start$)
                          pdf_SetFont(fo$,Bold_val$,sz)
                          f_size=pdf_GetFontSize()
                          pdf_SetTextColor(c_txt_R,c_txt_G,c_txt_B)
                          pdf_Text(xp.f,yp.f+f_size,out_put$); Y adjusted to start at baseline(like printer)
                     
                     EndSelect
                      cmdamd_graf$=""; clear command
           EndSelect
     Next
      ;Debug "Stop"

      
      Select visning  ; select output media
        Case 0
            StopVectorDrawing()
          Case 1
            StopPrinting()
          Case 2
            pdf_Save(file$)
          RunProgram("SumatraPDF.exe",file$,"")
      EndSelect
Return
;////////////////init output load input string to array/////////////////////////////////////////////
   init_out:
   kontroll$ = StringField(Text$,1,"/*") ; First document controll code
  If Len(kontroll$)>1
    name_doc$ = StringField(kontroll$,1,","); Name of document (PDF and print)
    Pos_val$= StringField(kontroll$,2,",")  ; P fr portrtt L fr landscape
    ;Remove first ctrl string and load to array
        Text$ = Mid(Text$,Len(kontroll$)+4); Inputstrng utan frsta kontrollflt
             For yr=1 To rad_count ;Move to array
                rad_str$ = StringField(Text$,yr, Chr(13))
                ut_array.s(yr)=rad_str$
                ;
            Next
  EndIf
  Return
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 97
; FirstLine = 80
; Folding = --
; EnableXP
; Executable = preview_new_pdf.exe